pub struct Timer {
    start_time: std::time::Instant,
    last_time: std::time::Instant,
    current_time: std::time::Instant,
    delta_time: f32,
}

impl Timer {
    pub fn new() -> Self {
        Self {
            start_time: std::time::Instant::now(),
            last_time: std::time::Instant::now(),
            current_time: std::time::Instant::now(),
            delta_time: 0.0,
        }
    }

    pub fn update(&mut self) {
        self.current_time = std::time::Instant::now();
        self.delta_time = self
            .current_time
            .duration_since(self.last_time)
            .as_secs_f32();
        self.last_time = self.current_time;
    }

    pub fn delta_time(&self) -> f32 {
        self.delta_time
    }

    pub fn start_time(&self) -> std::time::Instant {
        self.start_time
    }
}
